package it.unibz.inf.completeness.experiment;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;

public class QueryEvalMeasurement {

	public int queryLength;
	public double queryEvalTime;
	
	public QueryEvalMeasurement(int queryLength, double queryEvalTime) {
		this.queryLength = queryLength;
		this.queryEvalTime = queryEvalTime;
	}
	
	public static void printAvgQueryEvalTime(List<QueryEvalMeasurement> measurements) {

		long totalQueryEvalTime = 0;
		for(QueryEvalMeasurement measurement : measurements) {
			totalQueryEvalTime += measurement.queryEvalTime;
		}
		System.out.println("####################");
		System.out.println("AVG QUERY EVALUATION TIME FROM " + measurements.size() + " QUERIES: " + (((double) totalQueryEvalTime)/((double) measurements.size())) + " ms");
		
	}

	public static void groupByLength(List<QueryEvalMeasurement> measurements) {

		HashMap<Integer, List<Double>> hashmap = new HashMap<Integer, List<Double>>();
		for(QueryEvalMeasurement measurement : measurements) {
			int groupParameter = measurement.queryLength;
			if(!hashmap.containsKey(groupParameter)) {
				List<Double> thisList = new ArrayList<Double>();
				thisList.add(measurement.queryEvalTime);
				hashmap.put(groupParameter, thisList);
			} else {
				hashmap.get(groupParameter).add(measurement.queryEvalTime);
			}
		}
		
		// pretty printing
		System.out.println("####################");
		System.out.println("STATISTICS");
		System.out.println("Grouped by query length:");
		System.out.println("query length, number of queries, average query eval time");
		List<Integer> integerList = new ArrayList<Integer>(hashmap.keySet());
		Collections.sort(integerList);
		for(int key : integerList) {
			System.out.println(key + ", " + hashmap.get(key).size() + ", " + Measurement.avgOf(hashmap.get(key)));
		}
		
	}
	
}
