package it.unibz.inf.completeness.misc;

import it.unibz.inf.completeness.CompletenessReasoner;
import it.unibz.inf.completeness.CompletenessStatement;
import it.unibz.inf.completeness.ConstantMap;
import it.unibz.inf.semweb.QueryToolkit;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.io.IOUtils;

import org.apache.jena.query.QueryFactory;
//import org.apache.jena.rdf.model.InfModel;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.reasoner.Reasoner;
import org.apache.jena.reasoner.ReasonerRegistry;

public class RDFSTesting {

	public static void main(String[] args) {
		
//		String queryStr = "SELECT * WHERE { ?x <http://dbpedia.org/ontology/reservations> <http://example.org/something> . ?x <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> <http://schema.org/Hospital> . ?x <http://example.org/p> \"bla\" }";
		String queryStr = "SELECT  * WHERE { ?value  <http://dbpedia.org/property/alt>  \"A state map highlighting Indian River County in the eastern part of the state. It is small in size.\"@en }";

		System.out.println(QueryToolkit.freezeAsModel(QueryToolkit.body(QueryFactory.create(queryStr))));
		System.exit(0);
		
		List<CompletenessStatement> csList = new ArrayList<CompletenessStatement>();
		String csStr = "SELECT * WHERE { ?x <http://dbpedia.org/ontology/reservations> <http://example.org/something> . ?x <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> <http://dbpedia.org/ontology/Restaurant> . ?x <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> <http://dbpedia.org/ontology/Hospital> . ?x <http://example.org/p> \"bla\" }";
		CompletenessStatement cs = new CompletenessStatement(QueryToolkit.body(QueryFactory.create(csStr)));
		csList.add(cs);
		
	    Model rdfsSchema = ModelFactory.createDefaultModel();
	    rdfsSchema.read("dbpedia.ttl", "TURTLE");
		System.out.println("Schema size: " + rdfsSchema.size());
		
		System.out.println("Complete? " + CompletenessReasoner.checkSchemaCompletenessNaiveWithRDFSNaive(QueryToolkit.body(QueryFactory.create(queryStr)), csList, rdfsSchema));
		
		Reasoner reasoner = ReasonerRegistry.getRDFSSimpleReasoner();
		reasoner.bindSchema(rdfsSchema);
//		InfModel infSchemaModel = ModelFactory.createInfModel(reasoner, rdfsSchema);
//		System.out.println("Complete? " + CompletenessReasoner.checkSchemaCompletenessOptimizedWithRDFSNaive(QueryToolkit.body(QueryFactory.create(queryStr)), new ConstantMap(csList), rdfsSchema, reasoner, infSchemaModel));
		System.out.println("Complete? " + CompletenessReasoner.checkSchemaCompletenessOptimizedWithRDFSNaive(QueryToolkit.body(QueryFactory.create(queryStr)), new ConstantMap(csList), rdfsSchema));

	}

	public static Model createRDFSSchemaManually() {
		
		String rdfsSchemaStr =
			    "<http://example.org/Human> <http://www.w3.org/2000/01/rdf-schema#subClassOf> <http://example.org/Person> . " +
			    "<http://example.org/Person> <http://www.w3.org/2000/01/rdf-schema#subClassOf> <http://example.org/Human> . ";
		Model rdfsSchema = null;
		try {
			rdfsSchema = ModelFactory.createDefaultModel().read(IOUtils.toInputStream(rdfsSchemaStr, "UTF-8"), null, "N-TRIPLES");
		} catch (IOException e) {
			e.printStackTrace();
		}
		return rdfsSchema;
		
	}

}
